unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, IdBaseComponent, IdComponent,
  IdTCPConnection, IdTCPClient, SyncObjs, IdStrings, Grids, ValEdit;

const maxsachet=10;
      maxpater=50;

type

  TForm1 = class(TForm)
    IdTCPClient1: TIdTCPClient;
    LabeledEdit1: TLabeledEdit;
    LabeledEdit2: TLabeledEdit;
    Button1: TButton;
    Button2: TButton;
    Timer1: TTimer;
    ListBox1: TListBox;
    SendCmdButt: TButton;
    CommandEdit: TLabeledEdit;
    ValueListEditor1: TValueListEditor;
    procedure IdTCPClient1Connected(Sender: TObject);
    procedure IdTCPClient1Disconnected(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Timer1Timer(Sender: TObject);
    procedure SendCmdButtClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    messages:TStringList;
    Vytahu,Podlazi:Integer;
    ParsedMessage:TStringList;
    Kapacita: Integer;
    MaximalniOdchylka:Integer;
    MaximalniRychlost:Integer;
    MaximalniZrychleni:Integer;
    NouzovaDoba:Integer;
    HloubkaSachty:Integer;                          {Up,Down}
    CestujiciVPatrech:array[0..maxpater,1..2]of Boolean;
    PolohaVytahu:array[0..maxsachet] of integer;
    SmerVytahu:array[0..maxsachet] of integer;
    LidiVeVytahu:array[0..maxsachet] of integer;
    WaitForClose:array[0..maxsachet] of integer;
    Otevren:array[0..maxsachet] of boolean;
    Targets:array[0..maxsachet,0..maxpater] of boolean; 
    ShouldReset:Boolean;
    Update, Clearing: Integer;
    Refresh:Integer;
    procedure GetInfo;
    procedure ParseMessages;
    procedure PocetPodlazi;
    procedure PocetVytahu;
    procedure SendCommand(str: String);
    procedure GetKapacita;
    procedure GetMaximalniOdchylka;
    procedure GetMaximalniRychlost;
    procedure GetMaximalniZrychleni;
    procedure GetNouzovaDoba;
    procedure GetHloubkaSachty;
    procedure CvakaNahoru;
    procedure CvakaDolu;
    procedure GetPolohaVytahu;
    procedure ProcessOpened;
    procedure StartMoving;
    procedure ProcessClosed;
    procedure ProcessCabButton;
    procedure ProcessBlocked;
  end;

const LineEnd=#13#10;

var
  Form1: TForm1;
implementation

{$R *.dfm}

procedure TForm1.IdTCPClient1Connected(Sender: TObject);
var i,j:integer;
begin
  ShouldReset:=false;
  Button1.Enabled:=false;
  Button2.Enabled:=true;
  messages.Clear;
  Podlazi:=-1;
  SendCmdButt.Enabled:=true;
  FillChar(CestujiciVPatrech,sizeof(boolean)*maxpater*2,false);
  FillChar(PolohaVytahu,sizeof(Integer)*(maxsachet+1),false);
  for i:=0 to maxsachet do
  begin
    LidiVeVytahu[i]:=0;
    SmerVytahu[i]:=-1;
    Otevren[i]:=true;
    for j:=0 to maxpater do
    begin
      Targets[i,j]:=false;
    end;
  end;
  GetInfo;
  Update:=5;
  Refresh:=15;
end;

procedure TForm1.IdTCPClient1Disconnected(Sender: TObject);
begin
  Button1.Enabled:=True;
  Button2.Enabled:=False;
  SendCmdButt.Enabled:=false;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  IdTCPClient1.Port:=StrToInt(LabeledEdit2.Text);
  IdTCPClient1.Host:=LabeledEdit1.Text;
  IdTCPClient1.Connect;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  IdTCPClient1.Disconnect;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  messages:=TStringList.Create;
  ParsedMessage:=TStringList.Create;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if IdTCPClient1.Connected then
  IdTCPClient1.Disconnect;
  messages.Free;
  ParsedMessage.Free;
end;


procedure TForm1.Timer1Timer(Sender: TObject);
var r:string;
    i,j:integer;
begin
  if not IdTCPClient1.Connected then exit;
  while ListBox1.Items.Count>50 do
  ListBox1.Items.Delete(0);
  Timer1.Enabled:=false;
  r:=' ';
  while r<>'' do
  begin
    r:=IdTCPClient1.ReadLn(LineEnd,20);
    if r<>'' then
    messages.Add(r);
  end;
  if messages.Count>0 then
  begin
    ListBox1.Items.AddStrings(messages);
    ParseMessages;
    messages.Clear;
  end;
  if ShouldReset and (Podlazi<>-1)then
  begin
    ShouldReset:=false;
    for i:=0 to Podlazi-1 do
    begin
      SendCommand('indiupoff '+IntTostr(i));
      SendCommand('indidnoff '+IntTostr(i));
      for j:=0 to Vytahu-1 do
      begin
        SendCommand('indioff '+IntToStr(j)+' '+IntTostr(i));
      end;
    end;
    for i:=0 to Vytahu-1 do
    begin
      Otevren[0]:=false;
      SendCommand('close '+IntToStr(i));
      SendCommand('floor '+IntToStr(i)+' '+IntToStr(Podlazi div 2));
      PolohaVytahu[i]:=Podlazi div 2;
      StartMoving;
    end;
  end;
  for i:=0 to Vytahu do
  if Otevren[i] then
  begin
    dec(WaitForClose[i]);
    if WaitForClose[i]=0 then
    begin
      SendCommand('close '+IntToStr(i));
    end;
  end;
  dec(update);
  if Update<=0 then
  begin
    StartMoving;
    Update:=5;
  end;
  dec(refresh);
  if refresh<=0 then
  begin
    for i:=0 to Podlazi-1 do
    begin
      CestujiciVPatrech[i,1]:=false;
      CestujiciVPatrech[i,2]:=false;
      SendCommand('indiupoff '+IntToStr(i));
      SendCommand('indidnoff '+IntToStr(i));
    end;
    refresh:=200;
  end;
  Timer1.Enabled:=true;
end;

procedure TForm1.SendCommand(str: String);
begin
  if IdTCPClient1.Connected then
  IdTCPClient1.Write(str+LineEnd);
end;

procedure TForm1.SendCmdButtClick(Sender: TObject);
begin
  SendCommand(CommandEdit.Text);
end;

procedure TForm1.GetInfo;
begin
  SendCommand('param');
  ShouldReset:=true;
end;

procedure TForm1.ParseMessages;
var i:integer;

begin
  for i:=0 to messages.Count-1 do
  begin
    ParsedMessage.Clear;
    SplitColumns(messages[i],ParsedMessage);
    if ParsedMessage.Count>0 then
    begin
      if UpperCase(ParsedMessage[0])='SHAFTS' then PocetVytahu;
      if UpperCase(ParsedMessage[0])='LEVELS' then PocetPodlazi;
      if UpperCase(ParsedMessage[0])='MAXONBOARD' then GetKapacita;
      if UpperCase(ParsedMessage[0])='MAXDEV' then GetMaximalniOdchylka;
      if UpperCase(ParsedMessage[0])='MAXSPEED' then GetMaximalniRychlost;
      if UpperCase(ParsedMessage[0])='MAXACCEL' then GetMaximalniZrychleni;
      if UpperCase(ParsedMessage[0])='EMERGENCYTIME' then GetNouzovaDoba;
      if UpperCase(ParsedMessage[0])='LEVELHEIGHT' then GetHloubkaSachty;
      if UpperCase(ParsedMessage[0])='LEVELBUTTONUP' then CvakaNahoru;
      if UpperCase(ParsedMessage[0])='LEVELBUTTONDN' then CvakaDolu;
      if UpperCase(ParsedMessage[0])='LEVEL' then GetPolohaVytahu;
      if UpperCase(ParsedMessage[0])='OPENED' then ProcessOpened;
      if UpperCase(ParsedMessage[0])='CLOSED' then ProcessClosed;
      if UpperCase(ParsedMessage[0])='CABINBUTTON' then ProcessCabButton;
      if UpperCase(ParsedMessage[0])='BLOCKED' then ProcessBlocked;
    end;
  end;
end;

procedure TForm1.PocetPodlazi;
var value:Integer;
begin
  if ParsedMessage.Count<2 then exit;
  if TryStrToInt(ParsedMessage[1],value) then Podlazi:=value;
  ValueListEditor1.Values['Podlazi']:=IntToStr(Podlazi);
end;

procedure TForm1.PocetVytahu;
var value:Integer;
begin
  if ParsedMessage.Count<2 then exit;
  if TryStrToInt(ParsedMessage[1],value) then Vytahu:=value;
  ValueListEditor1.Values['Vytahu']:=IntToStr(Vytahu);
end;

procedure TForm1.GetKapacita;
var value:Integer;
begin
  if ParsedMessage.Count<2 then exit;
  if TryStrToInt(ParsedMessage[1],value) then Kapacita:=value;
  ValueListEditor1.Values['Kapacita']:=IntToStr(Kapacita);
end;

procedure TForm1.GetMaximalniOdchylka;
var value:Integer;
begin
  if ParsedMessage.Count<2 then exit;
  if TryStrToInt(ParsedMessage[1],value) then MaximalniOdchylka:=value;
  ValueListEditor1.Values['MaximalniOdchylka']:=IntToStr(MaximalniOdchylka);
end;

procedure TForm1.GetMaximalniRychlost;
var value:Integer;
begin
  if ParsedMessage.Count<2 then exit;
  if TryStrToInt(ParsedMessage[1],value) then MaximalniRychlost:=value;
  ValueListEditor1.Values['MaximalniRychlost']:=IntToStr(MaximalniRychlost);
end;

procedure TForm1.GetMaximalniZrychleni;
var value:Integer;
begin
  if ParsedMessage.Count<2 then exit;
  if TryStrToInt(ParsedMessage[1],value) then MaximalniZrychleni:=value;
  ValueListEditor1.Values['MaximalniZrychleni']:=IntToStr(MaximalniZrychleni);
end;

procedure TForm1.GetNouzovaDoba;
var value:Integer;
begin
  if ParsedMessage.Count<2 then exit;
  if TryStrToInt(ParsedMessage[1],value) then NouzovaDoba:=value;
  ValueListEditor1.Values['NouzovaDoba']:=IntToStr(NouzovaDoba);
end;

procedure TForm1.GetHloubkaSachty;
var value:Integer;
begin
  if ParsedMessage.Count<2 then exit;
  if TryStrToInt(ParsedMessage[1],value) then HloubkaSachty:=value;
  ValueListEditor1.Values['HloubkaSachty']:=IntToStr(HloubkaSachty);
end;

procedure TForm1.CvakaNahoru;
var value:Integer;
begin
  if ParsedMessage.Count<2 then exit;
  if TryStrToInt(ParsedMessage[1],value) then
  if (value>=0) and (value<=Podlazi) then
  begin
    SendCommand('indiupon '+IntToStr(value));
    CestujiciVPatrech[value,1]:=true;
    StartMoving;
  end;
end;

procedure TForm1.CvakaDolu;
var value:Integer;
begin
  if ParsedMessage.Count<2 then exit;
  if TryStrToInt(ParsedMessage[1],value) then
  if (value>=0) and (value<=Podlazi) then
  begin
    SendCommand('indidnon '+IntToStr(value));
    CestujiciVPatrech[value,1]:=true;
    StartMoving;
  end;
end;

procedure TForm1.GetPolohaVytahu;
var index,patro:Integer;
begin
  if ParsedMessage.Count<3 then exit;
  if TryStrToInt(ParsedMessage[1],index) then
  if TryStrToInt(ParsedMessage[2],patro) then
  begin
    PolohaVytahu[index]:=patro;
    if LidiVeVytahu[index]<Kapacita then
     if {(SmerVytahu[index]=-1) and} (CestujiciVPatrech[patro,1]) then
      begin
        SendCommand('open '+IntToStr(index));
        WaitForClose[index]:=100;
      end;
    if LidiVeVytahu[index]<Kapacita then
     if {((SmerVytahu[index]=1))and} (CestujiciVPatrech[patro,2]) then
      begin
        SendCommand('open '+IntToStr(index));
        WaitForClose[index]:=100;
      end;
    if Targets[index,patro] then
    begin
      SendCommand('open '+IntToStr(index));
      WaitForClose[index]:=100;
      targets[index,patro]:=false;
    end;
  end;
end;

procedure TForm1.ProcessOpened;
var value,i:Integer;
begin
  if ParsedMessage.Count<2 then exit;
  if TryStrToInt(ParsedMessage[1],value) then
  begin
    LidiVeVytahu[value]:=0;
    for i:=0 to Podlazi-1 do
    SendCommand('indioff '+IntToStr(value)+' '+IntToStr(i));
    Otevren[value]:=true;
    case SmerVytahu[value] of
    -1:SendCommand('indiupoff '+IntToStr(value));
     1:SendCommand('indidnoff '+IntToStr(value));
    end;
    CestujiciVPatrech[PolohaVytahu[value],1]:=false;
    CestujiciVPatrech[PolohaVytahu[value],2]:=false;
    Targets[value,PolohaVytahu[value]]:=false;
    SendCommand('indioff '+IntToStr(value)+' '+IntToStr(PolohaVytahu[value]));
  end;
end;

procedure TForm1.StartMoving;
var i,j,low,high:Integer;
    found:Boolean;
begin
  for j:=0 to Vytahu-1 do
  if not Otevren[j] then
  begin
    if LidiVeVytahu[j]=0 then
    begin
      found:=false;
      low:=PolohaVytahu[j]-1;
      high:=low+2;
      repeat
       if low>=0 then
        if CestujiciVPatrech[low,1] or CestujiciVPatrech[low,2] then
        begin
          found:=true;
          SendCommand('floor '+IntToStr(j)+' '+IntToStr(low));
          SmerVytahu[j]:=1;
        end;
       if low>=0 then
       dec(low);
       if (high<Podlazi) and (not found) then
        if CestujiciVPatrech[high,1] or CestujiciVPatrech[high,2] then
        begin
          found:=true;
          SendCommand('floor '+IntToStr(j)+' '+IntToStr(high));
          SmerVytahu[j]:=-1;
        end;
      if high<Podlazi then
      inc(high);
      until found or ((low=-1) and (high=Podlazi));
    end else
    begin
      found:=false;
      low:=PolohaVytahu[j];
      high:=low;
      repeat
       if low>=0 then
        if Targets[j,low] then
        begin
          found:=true;
          SendCommand('floor '+IntToStr(j)+' '+IntToStr(low));
          SmerVytahu[j]:=1;
        end;
       if low>=0 then
       dec(low);
       if (high<Podlazi) and (not found) then
        if Targets[j,high] then
        begin
          found:=true;
          SendCommand('floor '+IntToStr(j)+' '+IntToStr(high));
          SmerVytahu[j]:=-1;
        end;
      if high<Podlazi then
      inc(high);
      until found or ((low=-1) and (high=Podlazi));
    end;
    if targets[j,PolohaVytahu[j]] then
     SendCommand('open '+IntToStr(j)+' '+IntToStr(PolohaVytahu[j]));
  end;
end;

procedure TForm1.ProcessClosed;
var index:Integer;
begin
  if ParsedMessage.Count<2 then exit;
  if TryStrToInt(ParsedMessage[1],index) then
  begin
    Otevren[index]:=false;
    SendCommand('indiupoff '+IntToStr(PolohaVytahu[index]));
    SendCommand('indidnoff '+IntToStr(PolohaVytahu[index]));
    CestujiciVPatrech[PolohaVytahu[index],1]:=false;
    CestujiciVPatrech[PolohaVytahu[index],2]:=false;
    StartMoving;
  end;
end;

procedure TForm1.ProcessCabButton;
var index,patro:Integer;
begin
  if ParsedMessage.Count<3 then exit;
  if TryStrToInt(ParsedMessage[1],index) then
  if TryStrToInt(ParsedMessage[2],patro) then
  begin
    targets[index,patro]:=true;
    LidiVeVytahu[index]:=1;
    StartMoving;
    SendCommand('indion '+IntToStr(index)+' '+IntToStr(patro));
  end;
end;

procedure TForm1.ProcessBlocked;
var index:Integer;
begin
  if ParsedMessage.Count<2 then exit;
  if TryStrToInt(ParsedMessage[1],index) then
  begin
    WaitForClose[index]:=100;
  end;
end;

end.
